#######################################################
# README file for MSDLINES 
# version 02: vie mar 20 15:05:17 CET 2015
# jmaldonado at inaf-oapa 
#-----------------------------------------------------
# See Maldonado et al. (2015, submitted) for details.
# Please report any bug or suggestion to:
# jmaldonado@astropa.inaf.it
#######################################################

O. System requirements:
------------------------------------------------------
 It requires the gfortran compiler and the CFITSIO
 library (http://heasarc.nasa.gov/fitsio/fitsio.html).

** NOTE **********************************************
 This code was developed for HARPS / HARPS-N spectra.
 We caution that our methods are untested or unreliable
 on other spectrographs.
******************************************************* 

1. Files description:   
------------------------------------------------------ 

* 'harpn_all_4424_identified_features.dat': It contains
   the original list of identified features.

* 'stars_list.txt': File containing the list of stars
   to be calibrated. 

* 'msdlines.f90': Main program. It computes the pseudo
   equivalent widths and call the subroutines
   for stellar parameters determination.

* 'coefficients_Mstars_ratios_teff_ver02.dat':
   It contains the coefficients for computing the 
   effective temperature.  

* 'msdteff.f90': Subroutine
   to compute the effective temperature.

* 'coefficients_Mstars_ratios_sptype_ver02.dat':
   It contains the coefficients for computing the 
   spectral types.

* 'msdstypes.f90': Subroutine
   to determine the spectral type.

* 'coefficients_Mstars_ratios_metallicity_ver02.dat':
   It contains the coefficients for computing the stellar
   metallicity.

* 'msdmetal.f90': Subroutine
   to determine the stellar metallicity.

* 'msdlgmr.f90:': Subroutine for gravity, mass,
   radii, and luminosity determination. 

* 'Makefile': Makefile to compile the code

* 'gj15A.asc' and 'gj205.asc': Spectra of two stars
   to demonstrate how the code works. 

* 'README.txt': This file 
 

2. How to run the code:
------------------------------------------------------
   The list of stars to be calibrated should be included
in the 'stars_list.txt' file. The first raw of the file
should not be deleted. The second line gives the format
of the spectra. It could be either ASCII ('ascii') or
one dimensional FITS spectra ('fits'). The third raw of
the file should not be deleted. The rest of the 
lines should contain two arguments for each star:
i) a star identifier and ii) its corresponding
stellar spectra. The spectra should be in the same directory
where all the programs are. 

   The Makefile provided with the code can be used to compute
it, generating an executable file called MSDLINES (just write
make). Please, check your path to the cfitsio library and your
FORTRAN compiler. The cfitsio library is needed to read the input spectra in 
fits format. See, http://heasarc.nasa.gov/fitsio/fitsio.html
for details on how to install it if needed. 


3. Outputs:
------------------------------------------------------  
  The code produces an individual file for each star
in the 'star_list.txt' file with the extension *psdEWs.dat.
These files contain the measured pseudo equivalent widths.
It also produces three auxiliary files: 'derived_metallicities.dat'                                 
'derived_sptypes.dat', and  'derived_temperatures.dat' whose
contents are self-explanatory. Do not change the names of these
files in the codes. 

  The main output of the code is the file 'msd_summary_stellar_parameters.txt'
which contains all the derived stellar parameters. A value of "-99.0" is 
given if the star falls out of the range of applicability of our
calibrations.  

!<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! MSDlines subroutine for computing the stellar metallicity
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
! last change: dom mar  1 11:46:09 CET 2015
! jmaldonado at inaf-oapa
!><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! --- Definition of variables
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   subroutine msdmetal
   implicit none

   integer,parameter                  :: n_features     =  4424
   integer,parameter                  :: n_ratios       =   696
   character(80),parameter            :: input_file     = 'stars_list.txt'
   character(60),parameter            :: coeff_file     = 'coefficients_Mstars_ratios_metallicity_ver02.dat'
   character(80),parameter            :: ofile          = 'derived_metallicities.dat'
   real,parameter                     :: null_value     =  -99.
   character(30)                      :: ews_file
   character(15)                      :: star_identifier
   character(35)                      :: stellar_spectra
   real,dimension(n_ratios)           :: numerador, denominador, feature
   real,dimension(n_ratios)           :: variance, sigma, p0, p1, p2, rap
   real,dimension(n_features)         :: wavelength, width
   character(5),dimension(n_features) :: feature_id
   integer,dimension(n_ratios)        :: n1, n2, n3 
   real,dimension(n_features)         :: ew, e_ew
   real,dimension(n_ratios)           :: ratio_numerador, ratio_denominador
   real,dimension(n_ratios)           :: ratio_enumerador, ratio_edenominador
   real,dimension(n_ratios)           :: ratio_feature, ratio_efeature
   real,dimension(n_ratios)           :: ratio, e_ratio     
   real,dimension(n_ratios)           :: metal_ratio, emetal_ratio
   real,dimension(n_ratios)           :: min_ratio, max_ratio, min_feature, max_feature
   integer                            :: length 
   integer                            :: n_good
   real                               :: mean_metal, emean_metal
   integer                            :: ii, jj, kk, ios, jos

! ------------------------------------------------------
!  Open and read necessary files 
! ------------------------------------------------------

   ! *** File containing the fit to the selected ratios
   open(1,file=coeff_file,status='old',action='read')
   read(1,*)
   do ii = 1, n_ratios
   read(1,*) n1(ii), n2(ii), n3(ii), numerador(ii), denominador(ii), feature(ii), & 
             p0(ii), p1(ii), p2(ii), sigma(ii), rap(ii), min_ratio(ii), max_ratio(ii), &
             min_feature(ii), max_feature(ii)
   end do
   close(1)

   ! *** Headers in the output file
   open(3,file=ofile,status='unknown')
   write(3,10)  '# Star_identifier, Metallicity, eMetallicity'

! ------------------------------------------------------
!  Open the files containing the EWs and compute Teff
! ------------------------------------------------------

   open(5,file=input_file,status='old',action='read')
   read(5,*)  ! Three first lines
   read(5,*)
   read(5,*)
   do
   read(5,*,iostat=ios) star_identifier, stellar_spectra
   if (ios/=0) exit

      length    = len_trim(star_identifier)
      ews_file  = star_identifier(1:length)//'_psdEWs.dat'

      open(2,file=ews_file,status='old',action='read')
      read(2,*)  ! Three first lines are useless
      read(2,*)
      read(2,*)
           do ii = 1, n_features
              read(2,*)  feature_id(ii), wavelength(ii), ew(ii), e_ew(ii)
           end do
      close(2)


        do ii = 1, n_ratios   ! *** For each ratio 
    
           do jj = 1, n_features  ! *** Searching for the numerator
              if (wavelength(jj).eq.numerador(ii)) then
                  ratio_numerador(ii)  = ew(jj)
                  ratio_enumerador(ii) = e_ew(jj)
              end if
           end do
    
           
           do jj = 1, n_features  ! *** Searching for the denominator
              if (wavelength(jj).eq.denominador(ii)) then 
                  ratio_denominador(ii)   = ew(jj)
                  ratio_edenominador(ii)  = e_ew(jj)
              end if
           end do   


           do jj = 1, n_features ! *** Searching for the feature
              if (wavelength(jj).eq.feature(ii)) then
                  ratio_feature(ii)  = ew(jj)
                  ratio_efeature(ii) = e_ew(jj)
              end if
           end do 

                         
           ! *** Computing the ratio and its corresponding metallicity
           if (ratio_numerador(ii).ne.null_value.AND.ratio_denominador(ii).ne.null_value &
              .AND.ratio_feature(ii).ne.null_value) then

           ratio(ii)   = ratio_numerador(ii)/ratio_denominador(ii)  
           e_ratio(ii) = ratio(ii)*sqrt((ratio_enumerador(ii)/ratio_numerador(ii))**2 + &
                                 (ratio_edenominador(ii)/ratio_denominador(ii))**2)


           
           ! *** Cheking the calibration's limits
             if (ratio(ii).gt.min_ratio(ii).AND.ratio(ii).lt.max_ratio(ii).AND.  &
                 ratio_feature(ii).gt.min_feature(ii).AND.ratio_feature(ii).lt.max_feature(ii)) then  

           metal_ratio(ii)  = p0(ii)*ratio_feature(ii) + p1(ii)*ratio(ii) + p2(ii) 
           emetal_ratio(ii) = sqrt((p0(ii)*ratio_efeature(ii))**2 + (p1(ii)*e_ratio(ii))**2 &
                                  + sigma(ii)**2)  

              else
                metal_ratio(ii)  = null_value
                emetal_ratio(ii) = null_value
             end if  ! End of 'checking the calibration's limits  

            else
                ratio(ii)        = null_value
                e_ratio(ii)      = null_value  
                metal_ratio(ii)  = null_value
                emetal_ratio(ii) = null_value
            end if 


        end do  ! *** End of "for each ratiio ...'


    ! *** "Final" Metallicity and error
     mean_metal  = 0.0
     emean_metal = 0.0
     n_good  = 0  

 
     do ii = 1, n_ratios
       ! *** Just in case some fit gives a ridiculus value for some star
       if (metal_ratio(ii).ge.-3.0.AND.metal_ratio(ii).le.3.0.AND.metal_ratio(ii).ne. &
           null_value) then 
           mean_metal  = mean_metal  + metal_ratio(ii)
           emean_metal = emean_metal + emetal_ratio(ii)  
           n_good = n_good + 1
       end if
    end do  


  ! *** At least one good metallicity value is needed to give a median value
   if (n_good.ge.1) then
   mean_metal  = mean_metal/(n_good*1.0)
   emean_metal = emean_metal/(n_good*1.0)
   else
   mean_metal  = null_value
   emean_metal = null_value
   end if

  ! *** Writing results in output file
  write(3,15) star_identifier, mean_metal,  emean_metal

   end do ! *** End of 'For each star in input file ...'
   close(3)
   close(5)



10 format(A50) 
15 format(A35,1x,2(f12.2,1x)) 
20 format(A35,1x,13(f12.2,1x))

! ---- end of program ----------------------------------
   end subroutine

!<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! MAIN DRIVER FOR MSDLINES: It reads the spectra, computes the
! pseudo EWs, and calls the subroutines for stellar parameters
! computation  
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
! last change: dom mar  1 11:38:34 CET 2015 
! jmaldonado at inaf-oapa
!><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  program msdlines
  implicit none

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! --- Definition of variables
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  character(80),parameter                   :: input_file = 'stars_list.txt'
  character(5)                              :: input_type 
  character(12)                             :: star_identifier 
  character(80)                             :: stellar_spectra
  double precision,dimension(:),allocatable :: wavelength, flux
  integer                                   :: n_wavelengths
  integer                                   :: im, ier, readonly, blocksize
  character(80)                             :: comment, keyword
  integer                                   :: naxis, naxis1
  double precision                          :: crval
  real                                      :: cdelt
  integer                                   :: group, fpixel
  real                                      :: nulv
  logical                                   :: anyf
  integer                                   :: nbuffer
  real,dimension(:),allocatable             :: x
  integer                                   :: ii, jj, kk, ios, jos
  integer                                   :: longitud


!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! Reading input spectra
!<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  ! >>> Show help text
 
  write(*,*) '----------------------------------------------'
  write(*,*) ' Pseudo equivalent widths computation         '
  write(*,*) '----------------------------------------------'
 
  ! >>> Master file containing all the spectra to be analyzed
  open(3,file=input_file,status='old',action='read') 
  read(3,*) ! >> Line containing the headers
  read(3,*) input_type   !>> Input type should be either ascii or fits 
  read(3,*) ! >> More headers
  do
  read(3,*,iostat=ios) star_identifier, stellar_spectra
  if (ios/=0) exit

  ! *** Input spectra in ASCII format
  !----------------------------------------
  if (input_type.eq.'ascii') then 

       ! >>> Reading input spectra once to compute number of wavelengths
       n_wavelengths = 0
       open(1,file=stellar_spectra,status='old',action='read')
       do
       read(1,*,iostat=jos)
           if (jos/=0) exit
               n_wavelengths = n_wavelengths + 1
       end do
       close(1)

       ! >>> Allocate vectors
       allocate(wavelength(n_wavelengths))
       allocate(flux(n_wavelengths))

       ! >>> Reading wavelenghts and fluxes
       open(1,file=stellar_spectra,status='old',action='read')
       do ii = 1, n_wavelengths
          read(1,*) wavelength(ii), flux(ii)
       end do
       close(1) 

  ! *** Input spectra in FITS format
  !---------------------------------------- 

   else if (input_type.eq.'fits') then

       !*** Initialization of variables / Reading the fits file 
       readonly = 0
       call ftgiou(im,ier)
       call ftopen (im,stellar_spectra,readonly,blocksize,ier)

       !*** Checking if fits is one-dimensional
        call ftgkyj(im,'NAXIS',naxis,comment,ier)
             if (naxis.eq.0.OR.naxis.gt.1) then
                 write(*,*) '>> ERROR!: Multidimensionnal spectra not yet implemented ...'
                 write(*,*) 'Exiting now ...'
                stop
             end if
 
       !*** Reading headers data to reconstruct the wavelengths
       call ftgkyj(im,'NAXIS1',naxis1,comment,ier)
       call ftgkys(im,'CRVAL1',keyword,comment,ier)
       read( keyword, '(f24.12)' ) crval
       call ftgkys(im,'CDELT1',keyword,comment,ier)
       read( keyword, '(f12.8)' ) cdelt

       !*** Reading the fluxes
        nulv    = -1.0
        fpixel  = 1

       allocate(x(naxis1))
       call ftgpve(im,group,fpixel,naxis1,nulv,x,anyf,ier)
   
       !*** Writing fluxes and wavelengths   
       allocate(wavelength(naxis1))
       allocate(flux(naxis1))
        
       n_wavelengths = naxis1 

       do ii = 1, naxis1
          flux(ii) = x(ii)
       end do

       wavelength(1) = crval
       do ii = 2, naxis1
          wavelength(ii) = wavelength(ii-1) + cdelt
       end do

      !*** closing files 
      deallocate(x) 
      call ftclos(im,ier)
      call ftfiou(im,ier)
  
  ! *** 'Unknown' input spectra format
  !----------------------------------------
  else
     write(*,*) '>> ERROR!: Format of input spectra not recognized. Exiting now ...'
                 stop 
  end if 

!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! Calling the subroutine which computes the pseudo EWs
!<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  call pseudoEW (star_identifier,n_wavelengths,wavelength,flux)

  ! >>> Deallocate wavelength and flux
  deallocate(wavelength)
  deallocate(flux)

  end do ! >>> End of 'For each star in the input file ...'
  close(3)  

!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! 2nd part of the program: Stellar parameters computation
!<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  ! >>> Show help text

  write(*,*) '----------------------------------------------'
  write(*,*) ' Stellar parameters computation               '
  write(*,*) '----------------------------------------------'

 ! >>> Calling the subroutine for effective temperature computation
  call  msdteff 
 
 ! >>> Calling the subroutine for metallicity computation
  call  msdmetal

 ! >>> Calling the subroutine for spectral type determination
  call  msdstypes

 ! >>> Calling the subroutine for luminisoty, mass, gravity
  call msdlgmr

  write(*,*) '-----------------------------------------------'
  write(*,*) ' DONE! See msd_summary_stellar_parameters file '
  write(*,*) '-----------------------------------------------'


!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   end program

!====================================================================
! Functions and subroutines
!====================================================================

! -------------------------------------------------------------------
! Subroutine for computing the pseudo EWs
! -------------------------------------------------------------------

  subroutine pseudoEW(star_id,n_wave,wave,flx)
  implicit none

  real,parameter                          :: tol             =  5e-3
  real,parameter                          :: nwave_step      =  0.01
  integer,parameter                       :: n_features      =  4424
  character(80),parameter                 :: features_file   =  'harpn_all_4424_identified_features.dat'
  real,parameter                          :: null_ew         =  -99.0
  real,parameter                          :: min_ew          =    8.0
  real,parameter                          :: max_ew          =  120.0
  character(50)                           :: output_file
  character(12)                           :: star_id
  integer                                 :: n_wave
  double precision,dimension(n_wave)      :: wave, flx 
  integer                                 :: length
  integer,dimension(3)                    :: today, now
  character(5),dimension(n_features)      :: feature_id
  real,dimension(n_features)              :: feature_center, feature_width
  real,dimension(n_features)              :: feature_wave_low, feature_wave_upp
  real,dimension(n_features)              :: feature_flux_low, feature_flux_upp
  real,dimension(n_features)              :: ew, e_ew, slope, ordinate
  real,dimension(n_features)              :: n_points, mean_flux, sigma_flux
  real,dimension(n_features)              :: mean_ptp, mean_wave_step
  real                                    :: wave_step 
  integer                                 :: ii, jj

  ! >>> Name and headers in the output file
  length       = len_trim(star_id)
  output_file  = star_id(1:length)//'_psdEWs.dat'

  open(2,file=output_file,status='unknown')
  call idate(today)
  call itime(now)
  write(2,30) today(2), today(1), today(3), now
  write(2,35) '# Pseudo EW of selected features (mA) for star: ', star_id
  write(2,45) '# Feature ', 'Wavelength', 'pseudoEW  ', 'error    '

  ! >>> Show some info in the screen 
  write(*,50) ' Computing pseudo EWs for star : ', star_id

  ! >>> Reading the file containing the features information

   open(5,file=features_file,status='old',action='read')
   read(5,*)
      do ii = 1, n_features
         read(5,*) feature_id(ii), feature_center(ii), feature_width(ii)
         feature_wave_low(ii) = feature_center(ii) - (feature_width(ii)/2.0)
         feature_wave_upp(ii) = feature_center(ii) + (feature_width(ii)/2.0)
      end do
   close(5)


  !>>> For each line, computes the pseudo equivalent width 
  do ii = 1, n_features
     ew(ii)  = 0.0  ! >> EWs initialized to zero 
     n_points(ii)       = 0.0  ! *** Variables for error computation
     mean_wave_step(ii) = 0.0
     mean_flux(ii)      = 0.0
     sigma_flux(ii)     = 0.0
     mean_ptp(ii)       = 0.0

     do jj = 1, n_wave
        ! >> Fluxes at the limits of the integration (wave_low, wave_upp)
        if (abs(feature_wave_low(ii) - wave(jj)).lt.tol) then
             feature_flux_low(ii) = flx(jj)

        end if
        if (abs(feature_wave_upp(ii) - wave(jj)).lt.tol) then
             feature_flux_upp(ii) = flx(jj)
        end if
     end do


     ! >> Slope and ordinate of the line connecting the two integration limits
     slope(ii) = (feature_flux_low(ii) - feature_flux_upp(ii))/(feature_wave_low(ii) - feature_wave_upp(ii))
     ordinate(ii) = feature_flux_low(ii) - (slope(ii)*feature_wave_low(ii))

     ! >> Read again the spectra once more to compute the pseudo equivalent width 
     ! Flux peak to peak = "  slope(i)*wavelength(j) + ordinate(i) "
     do jj = 2, n_wave
        if (wave(jj).ge.feature_wave_low(ii).AND.wave(jj).le.feature_wave_upp(ii)) then

        wave_step = wave(jj) -  wave(jj-1)
        ew(ii) = ew(ii) +  ((((slope(ii)*wave(jj) + ordinate(ii)) - flx(jj))/ &
                           (slope(ii)*wave(jj) + ordinate(ii)))*wave_step)

        mean_flux(ii)      = mean_flux(ii) + flx(jj)
        mean_wave_step(ii) = mean_wave_step(ii) + wave_step
        mean_ptp(ii)       = mean_ptp(ii) + (slope(ii)*wave(jj) + ordinate(ii))
        n_points(ii)       = n_points(ii) + 1

       end if
     end do

     mean_flux(ii)      = mean_flux(ii)/n_points(ii)
     mean_wave_step(ii) = mean_wave_step(ii)/(n_points(ii))
     mean_ptp(ii)       = mean_ptp(ii)/(n_points(ii))

     ! >> Read a third time to compute the flux variance
     do jj = 2, n_wave
        if (wave(jj).ge.feature_wave_low(ii).AND.wave(jj).le.feature_wave_upp(ii)) then
            sigma_flux(ii) = sigma_flux(ii) + (flx(jj) - mean_flux(ii))**2
       end if
     end do

     sigma_flux(ii) = sqrt(sigma_flux(ii))/(n_points(ii) - 1.0)

    ! >> Sigma in the measured EWs
     e_ew(ii) = (mean_wave_step(ii)/mean_ptp(ii))*sigma_flux(ii)

    ! >> Fom A to mA
     ew(ii)   = ew(ii)*1000.
     e_ew(ii) = e_ew(ii)*1000.

    ! >> Set null_ew value for too weak/too strong lines 
     if (ew(ii).gt.max_ew.OR.ew(ii).lt.min_ew) then
         ew(ii)   = null_ew
         e_ew(ii) = null_ew
     end if

    ! >> Write results in output file (pseudo EWs in mA)
    write(2,55) feature_id(ii), feature_center(ii), ew(ii), e_ew(ii)

  end do  ! >> End of 'For each feature ...'

  close(2)
  
30 format('# Date ', i2.2, '/', i2.2, '/', i4.4, '; time ', i2.2, ':', i2.2, ':', i2.2 )
35 format(A48,1x,A12)
45 format(4(A10,1x))
50 format(A33,1x,A12)
55 format(A5,1x,3(f12.2,1x))

  end subroutine pseudoEW

! -------------------------------------------------------------------
! Fitsio subroutine printerror
! -------------------------------------------------------------------

  subroutine printerror(status)
  implicit none

  ! Print out the FITSIO error messages to the user

  integer  :: status
  character(30) :: errtext
  character(80) :: errmessage

  ! Check if status is OK (no error); if so, simply return
  if (status .le. 0)return

 ! Get the text string which describes the error
  call ftgerr(status,errtext)
  print *,'FITSIO Error Status =',status,': ',errtext

  ! Read and print out all the error messages on the FITSIO stack
  call ftgmsg(errmessage)
  do while (errmessage .ne. ' ')
     print *,errmessage
     call ftgmsg(errmessage)
  end do

  end subroutine printerror
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! MSDlines subroutine for determining masses, gravities and radius
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
! last change:  mar mar  3 11:57:42 CET 2015
! jmaldonado at inaf-oapa
!><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! --- Definition of variables
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  subroutine msdlgmr
  implicit none

  real,parameter    :: null_value            =  -99.
  real,parameter    :: stephan_boltzmann_cte =  5.67051e-5  ! (erg/cm^2*s*K^4) From Allen
  real,parameter    :: solar_radius          =  6.95508e10  ! (cm) From Allen
  real,parameter    :: solar_luminosity      =  3.845e33    ! (erg/s)  From Allen
  real,parameter    :: pi_number             =  3.141592654
  integer,parameter :: n_coefficients        =  5 
  integer,parameter :: n_outputs             =  14
  real,parameter    :: sigma_mass            =  0.0206811
  real,parameter    :: sigma_radius          =  0.0180707
  real,parameter    :: sigma_logg            =  0.0181498
  character(50),parameter  :: teff_file      =  'derived_temperatures.dat'
  character(50),parameter  :: metal_file     =  'derived_metallicities.dat'
  character(50),parameter  :: sptype_file    =  'derived_sptypes.dat'
  character(50),parameter  :: ofile          =  'msd_summary_stellar_parameters.txt'
  character(12),dimension(:),allocatable    :: star_identifier
  character(12)                             :: borra  
  real,dimension(:),allocatable             :: teff, eteff, metal, emetal, sptype
  real,dimension(:),allocatable             :: mass, emass, radius, eradius, logg, elogg
  real,dimension(:),allocatable             :: luminosity, eluminosity   
  real,dimension(n_coefficients)            :: c_mass, c_radius, c_logg
  integer                                   :: n_stars     
  character(13),dimension(n_outputs)        :: headers
  integer                                   :: ii, jj, kk, ios, jos

! ------------------------------------------------------
!  Open and read necessary files 
! ------------------------------------------------------

   ! >>> Computing n_stars
   n_stars = 0
   open(1,file=teff_file,status='old',action='read')
   read(1,*) ! >>> Headers
   do 
   read(1,*,iostat=ios)
       if (ios/=0) exit
           n_stars = n_stars + 1
   end do 
   close(1)

   ! >>> Allocate vectors
   allocate(star_identifier(n_stars))
   allocate(teff(n_stars))
   allocate(eteff(n_stars))
   allocate(metal(n_stars))
   allocate(emetal(n_stars))
   allocate(sptype(n_stars))
   allocate(mass(n_stars))
   allocate(emass(n_stars))
   allocate(radius(n_stars))
   allocate(eradius(n_stars))
   allocate(logg(n_stars))
   allocate(elogg(n_stars))
   allocate(luminosity(n_stars))
   allocate(eluminosity(n_stars))      
 
   ! >>> Reading file containing teff
   open(1,file=teff_file,status='old',action='read')
   read(1,*) ! >>> Headers
   do ii = 1, n_stars
      read(1,*) star_identifier(ii), teff(ii), eteff(ii)
   end do
   close(1)

   ! >> Reading file containing metallicities
   open(2,file=metal_file,status='old',action='read')
   read(2,*) ! >>> Headers
   do jj = 1, n_stars
      read(2,*) borra, metal(jj), emetal(jj)
   end do 
   close(2)

   ! >> Reading file containing spectral types
   open(3,file=sptype_file,status='old',action='read')
   read(3,*) ! >>> Headers
   do kk = 1, n_stars
      read(3,*) borra, sptype(kk)
   end do 
   close(3)
   
! ------------------------------------------------------
!  Initialization of variables
! ------------------------------------------------------

  ! *** Output file headers
  headers = (/'# Star       ', 'Teff         ', 'eTeff        ', 'SpType       ',  &
              '[Fe/H]       ', 'e[Fe/H]      ', 'Mass         ', 'eMass        ',  &
              'Radius       ', 'eRadius      ', 'logg         ', 'elogg        ',  &
              'log(L*/Lsun) ', 'elog(L*/Lsun)'/)   

  ! *** Stellar Mass:
   c_mass   = (/-171.616, 0.139436, -3.776e-05, 3.41915e-09, 0.382057/)
  ! *** Stellar Radii:
   c_radius = (/-159.857, 0.130206, -3.53437e-05, 3.20786e-09, 0.346746/)
  ! *** Stellar logg:
   c_logg   = (/174.462, -0.137614, 3.72836e-05, -3.37556e-09, -0.332336/)

! ------------------------------------------------------
!  Computing Mass, Radius, logg, and Luminosity
! ------------------------------------------------------

  do ii = 1, n_stars ! For each star 

    ! *** Null value case 
     if (teff(ii).eq.null_value.OR.metal(ii).eq.null_value) then 
         mass(ii)        = null_value
         emass(ii)       = null_value
         radius(ii)      = null_value   
         eradius(ii)     = null_value
         logg(ii)        = null_value
         elogg(ii)       = null_value
         luminosity(ii)  = null_value
         eluminosity(ii) = null_value  
     else

      ! *** Mass
      mass(ii)    = c_mass(1) + c_mass(2)*teff(ii) + c_mass(3)*(teff(ii)**2) + c_mass(4)*(teff(ii)**3)  &
                  +  c_mass(5)*(metal(ii))

      ! *** Uncertainty in mass
      emass(ii)   = sqrt(((c_mass(2) + 2*c_mass(3)*(teff(ii))  + 3*c_mass(4)*(teff(ii)**2))*eteff(ii))**2 &
                  + (c_mass(5)*emetal(ii))**2 + (sigma_mass**2))
 
      ! *** Radii
      radius(ii)  = c_radius(1) + c_radius(2)*teff(ii) + c_radius(3)*(teff(ii)**2) + c_radius(4)*(teff(ii)**3)  &
                  + c_radius(5)*(metal(ii))          

      ! *** Uncertainty in radii
      eradius(ii) = sqrt(((c_radius(2) + 2*c_radius(3)*(teff(ii))  + 3*c_radius(4)*(teff(ii)**2))*eteff(ii))**2 &
                  + (c_radius(5)*emetal(ii))**2 + (sigma_radius**2))
 
      
      ! *** Gravity   
      logg(ii)    = c_logg(1) + c_logg(2)*teff(ii) + c_logg(3)*(teff(ii)**2) + c_logg(4)*(teff(ii)**3)  &
                  + c_logg(5)*(metal(ii))


      ! *** Uncertainty in gravity 
      elogg(ii)   = sqrt(((c_logg(2) + 2*c_logg(3)*(teff(ii)) + 3*c_logg(4)*(teff(ii)**2))*eteff(ii))**2 &
                  + (c_logg(5)*emetal(ii))**2 + (sigma_logg**2))


      ! *** Luminosity in solar units
      luminosity(ii) = 4*pi_number*((radius(ii)*solar_radius)**2)*stephan_boltzmann_cte*(teff(ii)**4)
      luminosity(ii) = luminosity(ii)/solar_luminosity

    
      ! *** Uncertainty in luminosity   
      eluminosity(ii) = sqrt(((2*luminosity(ii)*eradius(ii))/radius(ii))**2 + &
                        ((4*luminosity(ii)*eteff(ii))/teff(ii))**2) 

    
      ! *** Better provide logarithms
      ! >>> Note that errors should be computed before
      eluminosity(ii) = abs((1/(luminosity(ii)*log(10.0)))*eluminosity(ii))
      luminosity(ii)  = log10(luminosity(ii))
 

  
  end if ! End of 'null value' case
  end do ! End of 'for each star ...'

! ------------------------------------------------------
!   Writing results in output file 
! ------------------------------------------------------

  open(4,file=ofile,status='unknown')
  write(4,10) headers(:) ! headers in ofile
  do jj = 1, n_stars
      write(4,20) star_identifier(jj), teff(jj), eteff(jj), sptype(jj), metal(jj), emetal(jj), &
                  mass(jj), emass(jj), radius(jj), eradius(jj), logg(jj), elogg(jj),  &
                  luminosity(jj), eluminosity(jj)
  end do 
  close(4)


 ! >>> Deallocate vectors
   deallocate(star_identifier)
   deallocate(teff)
   deallocate(eteff)
   deallocate(metal)
   deallocate(emetal)
   deallocate(sptype)
   deallocate(mass)
   deallocate(emass)
   deallocate(radius)  
   deallocate(eradius) 
   deallocate(logg) 
   deallocate(elogg) 
   deallocate(luminosity) 
   deallocate(eluminosity) 


! --- Formats and end of program -----------------------------------
10   format(14(A17,1x))
20   format(A12,1x,2(f12.0,1x),1x,f6.1,1x,8(f12.2,1x),1x,2(f12.3,1x))

     end subroutine 

!<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! MSDlines subroutine for computing the effective temperature
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
! last change: vie mar 20 15:04:17 CET 2015
! jmaldonado at inaf-oapa
!><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! --- Definition of variables
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   subroutine msdteff
   implicit none
   
   integer,parameter                  :: n_features      =  4424 
   integer,parameter                  :: n_ratios        =   112 
   character(80),parameter            :: input_file      = 'stars_list.txt'
   character(60),parameter            :: coeff_file      = 'coefficients_Mstars_ratios_teff_ver02.dat' 
   character(80),parameter            :: ofile           = 'derived_temperatures.dat'
   real,parameter                     :: null_value      = -99.
   character(30)                      :: ews_file
   character(15)                      :: star_identifier
   character(35)                      :: stellar_spectra 
   character(8),dimension(n_ratios)   :: numerador, denominador
   character(2),dimension(n_ratios)   :: equation
   real,dimension(n_ratios)           :: variance, aH, bH, cH, sH, aMH, bMH, cMH, sMH
   real,dimension(n_ratios)           :: aPL, bPL, sPL, aE, bE, sE, aL, bL, sL, bestS
   real,dimension(n_ratios)           :: min_ratio_value, max_ratio_value   
   real,dimension(n_features)         :: wavelength, width
   character(5),dimension(n_features) :: feature_id 
   real,dimension(n_features)         :: ew, e_ew 
   real,dimension(n_ratios)           :: ratio_numerador, ratio_denominador
   real,dimension(n_ratios)           :: ratio_enumerador, ratio_edenominador
   real,dimension(n_ratios)           :: ratio, e_ratio     
   real,dimension(n_ratios)           :: teff_ratio, eteff_ratio
   integer                            :: length, n_good
   real                               :: mean_teff, emean_teff
   integer                            :: ii, jj, kk, ios, jos

! ------------------------------------------------------
!  Open and read necessary files 
! ------------------------------------------------------

   ! *** File containing the fit to the selected ratios
   open(1,file=coeff_file,status='old',action='read')
   read(1,*)
   do ii = 1, n_ratios
   read(1,*) numerador(ii), denominador(ii), aH(ii), bH(ii), cH(ii), sH(ii),       &
    aMH(ii), bMH(ii), cMH(ii), sMH(ii), aPL(ii), bPL(ii), sPL(ii), aE(ii), bE(ii), &
    sE(ii), aL(ii), bL(ii), sL(ii), bestS(ii), equation(ii), min_ratio_value(ii), max_ratio_value(ii)
   end do
   close(1)

   ! *** Headers in the output file
   open(3,file=ofile,status='unknown')
   write(3,10)  '# Star_identifier, Teff(K),  eTeff(K)'

! ------------------------------------------------------
!  Open the files containing the EWs and compute Teff
! ------------------------------------------------------

   open(5,file=input_file,status='old',action='read')
   read(5,*) ! First three lines are useless 
   read(5,*)
   read(5,*)
   do
   read(5,*,iostat=ios) star_identifier, stellar_spectra
   if (ios/=0) exit

      length    = len_trim(star_identifier)
      ews_file  = star_identifier(1:length)//'_psdEWs.dat'

      open(2,file=ews_file,status='old',action='read')
      read(2,*)  ! Threee first lines are useless
      read(2,*)
      read(2,*)
           do ii = 1, n_features 
              read(2,*)  feature_id(ii), wavelength(ii), ew(ii), e_ew(ii)
           end do
      close(2) 

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  Compute effective temperature for each ratio
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      do ii = 1, n_ratios   ! *** For each ratio 
    
         do jj = 1, n_features  ! *** Searching for the numerator
              if (feature_id(jj).eq.numerador(ii)) then
                  ratio_numerador(ii)  = ew(jj)
                  ratio_enumerador(ii) = e_ew(jj)
              end if
         end do
    
           
         do jj = 1, n_features  ! *** Searching for the denominator
              if (feature_id(jj).eq.denominador(ii)) then 
                  ratio_denominador(ii) = ew(jj)
                  ratio_edenominador(ii) = e_ew(jj)
              end if
         end do   


         ! *** Computing the ratio and its uncertainty
         ! *** Checking if pseudoEWs have good values

         if (ratio_numerador(ii).eq.null_value.OR.ratio_denominador(ii).eq.null_value) then
             ratio(ii)       = null_value
             e_ratio(ii)     = null_value
             teff_ratio(ii)  = null_value  
             eteff_ratio(ii) = null_value    
         else


         ratio(ii)   = ratio_numerador(ii)/ratio_denominador(ii)  
         e_ratio(ii) = ratio(ii)*sqrt((ratio_enumerador(ii)/ratio_numerador(ii))**2 + &
                     (ratio_edenominador(ii)/ratio_denominador(ii))**2)

        ! *** Computing the effective temperature for each ratio
        ! *** Checking if ratio is within the calibrations limits

          
        if (ratio(ii).gt.max_ratio_value(ii).OR.ratio(ii).lt.min_ratio_value(ii)) then 
               ratio(ii)      = null_value
               e_ratio(ii)    = null_value
               teff_ratio(ii) = null_value
              eteff_ratio(ii) = null_value
         else
             
           ! *** Checking the functional form of the calibration
           if (equation(ii).eq.'HO') then  ! *** Hoerl function

               teff_ratio(ii)  = aH(ii)*(bH(ii)**(ratio(ii)))*(ratio(ii)**cH(ii))
                
               eteff_ratio(ii) = ((teff_ratio(ii)*log(bH(ii)))  + &
                                 (teff_ratio(ii)*cH(ii))/ratio(ii))*e_ratio(ii) 

           else if (equation(ii).eq.'MH') then ! *** Modified Hoerl function
                       
               teff_ratio(ii)  = aMH(ii)*(bMH(ii)**(1.0/ratio(ii)))*(ratio(ii)**cMH(ii))
              
               eteff_ratio(ii) = ((teff_ratio(ii)*log(bH(ii))/(ratio(ii)**2))  + & 
                                 (teff_ratio(ii)*cH(ii))/ratio(ii))*e_ratio(ii)

           else if (equation(ii).eq.'PL') then ! *** Power-law function
               
               teff_ratio(ii)  = aPL(ii)*(ratio(ii)**bPL(ii))
               eteff_ratio(ii) = (aPL(ii)*bPL(ii)*(ratio(ii)**(bPL(ii)-1.0)))*e_ratio(ii)

           else if (equation(ii).eq.'EX') then  ! *** Teff = a * b^(r)

               teff_ratio(ii)  = aE(ii)*(bE(ii)**ratio(ii))
               eteff_ratio(ii) = teff_ratio(ii)*log(bE(ii))*e_ratio(ii) 

           else if (equation(ii).eq.'LO') then  ! *** Teff = a * bln(r)

               teff_ratio(ii)  =  aL(ii) + bL(ii)*log(ratio(ii))    
               eteff_ratio(ii) =  bL(ii)*(e_ratio(ii)/ratio(ii))


           end if 
       
               eteff_ratio(ii) = sqrt(eteff_ratio(ii)**2 + bestS(ii)**2) 

           end if ! *** End of 'check if ratio is within the calibration's limits'

           end if ! *** End of 'check for null_value case' 


        end do  ! *** End of "for each ratiio ...'


    ! *** "Final" teff and error
       mean_teff  = 0.0
       emean_teff = 0.0
       n_good = 0   


    do ii = 1, n_ratios
        ! *** Just in case some fit gives a ridiculus value for some star
        if (teff_ratio(ii).gt.1000.AND.teff_ratio(ii).lt.6000.AND.teff_ratio(ii).ne.null_value) then
            mean_teff   = mean_teff  + teff_ratio(ii)
            emean_teff  = emean_teff + eteff_ratio(ii)
            n_good = n_good + 1
        end if
    end do


  ! *** At least one good teff is needed to give a median value
   if (n_good.ge.1) then
   mean_teff  = mean_teff/(n_good*1.0)
   emean_teff = emean_teff/(n_good*1.0)
   else
   mean_teff  = null_value
   emean_teff = null_value
   end if

   ! *** Writing results in output file
     write(3,15) star_identifier, mean_teff,  emean_teff

   end do ! *** End of 'For each star in input file ...'
   close(3)
   close(5)

10 format(A40) 
15 format(A15,1x,2(f12.2,1x)) 

! ---- end of program ----------------------------------
   end subroutine

!<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
! MSDlines subroutine for determining the spectral type
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
! last change: dom mar  1 11:44:09 CET 2015
! jmaldonado at inaf-oapa
!><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! --- Definition of variables
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   subroutine msdstypes
   implicit none

   integer,parameter                  :: n_features     =  4424
   integer,parameter                  :: n_ratios       =    82
   character(80),parameter            :: input_file     = 'stars_list.txt'
   character(60),parameter            :: coeff_file     = 'coefficients_Mstars_ratios_sptype_ver02.dat'
   character(80),parameter            :: ofile          = 'derived_sptypes.dat'
   real,parameter                     :: null_value     =  -99.0 
   character(30)                      :: ews_file
   character(15)                      :: star_identifier
   character(35)                      :: stellar_spectra
   character(5),dimension(n_ratios)   :: numerador, denominador
   character(2),dimension(n_ratios)   :: equation
   real,dimension(n_ratios)           :: p0, p1, p2, p3, sigma, rap
   real,dimension(n_features)         :: wavelength, width
   character(8),dimension(n_features) :: feature_id 
   real,dimension(n_features)         :: ew, e_ew
   real,dimension(n_ratios)           :: ratio_numerador, ratio_denominador
   real,dimension(n_ratios)           :: ratio      
   real,dimension(n_ratios)           :: sptype_ratio
   real,dimension(n_ratios)           :: min_ratio, max_ratio
   real                               :: mean_sptype
   integer                            :: length
   integer                            :: n_good, entero
   real                               :: deci
   integer                            :: ii, jj, kk, ios, jos

! ------------------------------------------------------+
!  Open and read necessary files 
! ------------------------------------------------------+

   ! *** File containing the fit to the selected ratios
   open(1,file=coeff_file,status='old',action='read')
   read(1,*)
   do ii = 1, n_ratios
   read(1,*) numerador(ii), denominador(ii), p0(ii), p1(ii), p2(ii), p3(ii), sigma(ii), rap(ii), &
             min_ratio(ii), max_ratio(ii) 
   end do
   close(1)

   ! *** Headers in the output file
   open(3,file=ofile,status='unknown')
   write(3,10)  '# Star_identifier, sptype'


! ------------------------------------------------------
!  Open the files containing the EWs and compute SpType
! ------------------------------------------------------

   open(5,file=input_file,status='old',action='read')
   read(5,*) ! Three first lines
   read(5,*)
   read(5,*) 
   do
   read(5,*,iostat=ios) star_identifier, stellar_spectra
   if (ios/=0) exit

      length    = len_trim(star_identifier)
      ews_file  = star_identifier(1:length)//'_psdEWs.dat'

      open(2,file=ews_file,status='old',action='read')
      read(2,*)  ! Three first lines are useless
      read(2,*)
      read(2,*)
           do ii = 1, n_features
              read(2,*)  feature_id(ii), wavelength(ii), ew(ii), e_ew(ii)
           end do
      close(2)

      do ii = 1, n_ratios   ! *** For each ratio 
    
         do jj = 1, n_features  ! *** Searching for the numerator
            if (feature_id(jj).eq.numerador(ii)) then
                ratio_numerador(ii)  = ew(jj)
            end if
         end do
    
           
         do jj = 1, n_features  ! *** Searching for the denominator
            if (feature_id(jj).eq.denominador(ii)) then 
                ratio_denominador(ii) = ew(jj)
            end if
         end do   


        ! *** Computing the ratio and its corresponding SpType
        if (ratio_numerador(ii).ne.null_value.AND.ratio_denominador(ii).ne.null_value) then   

        ratio(ii)   = ratio_numerador(ii)/ratio_denominador(ii) 

        if (ratio(ii).gt.min_ratio(ii).AND.ratio(ii).lt.max_ratio(ii)) then  

        sptype_ratio(ii) =  p0(ii) + p1(ii)*ratio(ii) + p2(ii)*(ratio(ii)**2)  &
                            +  p3(ii)*(ratio(ii)**3)    

        else

        ! *** If ratio is outside calibration's limits  
        sptype_ratio(ii) = null_value

        end if 

        else

        ! *** Null value case        
        ratio(ii)        = null_value
        sptype_ratio(ii) = null_value  
        
        end if

      end do  ! *** End of "for each ratiio ...'

    ! *** Mean spectral type
     mean_sptype  = 0.0
     n_good     = 0
   
     do ii = 1, n_ratios
        ! **** Just in case
        if (sptype_ratio(ii).gt.-3.0.AND.sptype_ratio(ii).lt.7.0.AND.sptype_ratio(ii) &
            .ne.null_value) then
        mean_sptype   = mean_sptype  + sptype_ratio(ii) 
        n_good        = n_good +1  
        end if
     end do 


  ! *** At least one good sptype is needed to give a median value
   if (n_good.ge.1) then
   mean_sptype  = mean_sptype/(n_good*1.0)
   else
   mean_sptype  = null_value
   end if


     if (mean_sptype.ne.null_value) then      
     ! *** Redondeamos
     entero = int(mean_sptype)
     deci   = mean_sptype - entero

     if (mean_sptype.lt.-1) then
         write(*,*) 'Oh no! You have a late-K star, check: ', star_identifier
     else if (mean_sptype.lt.0.AND.deci.le.-0.75) then
         mean_sptype = -1
     else if (mean_sptype.lt.0.AND.deci.gt.-0.75.AND.deci.le.-0.25) then
         mean_sptype = -0.5
     else if (mean_sptype.lt.0.AND.deci.gt.-0.25) then
         mean_sptype =  0
     else if (deci.le.0.25) then
         mean_sptype = mean_sptype - deci
     else if (deci.gt.0.25.AND.deci.le.0.75) then
         mean_sptype = entero + 0.5
     else if (deci.gt.0.75) then
         mean_sptype = entero + 1
     end if

     end if  ! End of null value case 


   ! *** Writing results in output file

     write(3,15) star_identifier, mean_sptype

   end do  ! End of "For each star in the input file ...'
   close(5)
   close(3)


10 format(A50) 
15 format(A15,1x,f12.1) 

   end subroutine
